/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Argon2.xs. Do not edit this file, edit Argon2.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Crypt/Argon2.xs"
#define PERL_NO_GET_CONTEXT

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#include <argon2.h>

static size_t S_parse_size(pTHX_ SV* value, int type) {
	STRLEN len;
	const char* string = SvPVbyte(value, len);
	char* end = NULL;
	int base = strtoul(string, &end, 0);
	if (end == string)
		Perl_croak(aTHX_ "Couldn't compute %s tag: memory cost doesn't contain anything numeric", argon2_type2string(type, 0));
	switch(*end) {
		case '\0':
			if (base > 1024)
				return base / 1024;
			else
				Perl_croak(aTHX_ "Couldn't compute %s tag: Memory size much be at least a kilobyte", argon2_type2string(type, 0));
		case 'k':
			return base;
		case 'M':
			return base * 1024;
		case 'G':
			return base * 1024 * 1024;
		default:
			Perl_croak(aTHX_ "Couldn't compute %s tag: Can't parse '%c' as an order of magnitude", argon2_type2string(type, 0), *end);
	}
}
#define parse_size(value, type) S_parse_size(aTHX_ value, type)

typedef enum Argon2_type Argon2_type;
static Argon2_type S_find_argon2_type(pTHX_ const char* name, size_t name_len) {
	if (name_len == 8 && strnEQ(name, "argon2id", 8))
		return Argon2_id;
	else if (name_len == 7 && strnEQ(name, "argon2i", 7))
		return Argon2_i;
	else if (name_len == 7 && strnEQ(name, "argon2d", 7))
		return Argon2_d;
	Perl_croak(aTHX_ "No such argon2 type %s", name);
}
#define find_argon2_type(name, len) S_find_argon2_type(aTHX_ name, len)

static Argon2_type S_XS_unpack_Argon2_type(pTHX_ SV* name_sv) {
	STRLEN name_len;
	const char* name = SvPV(name_sv, name_len);
	return find_argon2_type(name, name_len);
}
#define XS_unpack_Argon2_type(name) S_XS_unpack_Argon2_type(aTHX_ name)

static SV* S_argon2_pass(pTHX_ Argon2_type type, SV* password, SV* salt, int t_cost, SV* m_factor, int parallelism, size_t output_length) {
	int m_cost = parse_size(m_factor, type);
	STRLEN password_len, salt_len;
	const char* password_raw = SvPVbyte(password, password_len);
	const char* salt_raw = SvPVbyte(salt, salt_len);
	size_t encoded_length = argon2_encodedlen(t_cost, m_cost, parallelism, salt_len, output_length, type);
	SV* result = newSV(encoded_length - 1);
	SvPOK_only(result);
	int rc = argon2_hash(t_cost, m_cost, parallelism,
		password_raw, password_len,
		salt_raw, salt_len,
		NULL, output_length,
		SvPVX(result), encoded_length,
		type, ARGON2_VERSION_NUMBER
	);
	if (rc != ARGON2_OK) {
		SvREFCNT_dec(result);
		Perl_croak(aTHX_ "Couldn't compute %s tag: %s", argon2_type2string(type, FALSE), argon2_error_message(rc));
	}
	SvCUR(result) = encoded_length - 1;
	return result;
}
#define argon2_pass(type, password, salt, t_cost, m_factor, parallelism, output_length) S_argon2_pass(aTHX_ type, password, salt, t_cost, m_factor, parallelism, output_length)

static SV* S_argon2_raw(pTHX_ Argon2_type type, SV* password, SV* salt, int t_cost, SV* m_factor, int parallelism, size_t output_length) {
	int m_cost = parse_size(m_factor, type);
	STRLEN password_len, salt_len;
	const char* password_raw = SvPVbyte(password, password_len);
	const char* salt_raw = SvPVbyte(salt, salt_len);
	SV* result = newSV(output_length);
	SvPOK_only(result);
	int rc = argon2_hash(t_cost, m_cost, parallelism,
		password_raw, password_len,
		salt_raw, salt_len,
		SvPVX(result), output_length,
		NULL, 0,
		type, ARGON2_VERSION_NUMBER
	);
	if (rc != ARGON2_OK) {
		SvREFCNT_dec(result);
		Perl_croak(aTHX_ "Couldn't compute %s tag: %s", argon2_type2string(type, FALSE), argon2_error_message(rc));
	}
	SvCUR(result) = output_length;
	return result;
}
#define argon2_raw(type, password, salt, t_cost, m_factor, parallelism, output_length) S_argon2_raw(aTHX_ type, password, salt, t_cost, m_factor, parallelism, output_length)

#line 110 "lib/Crypt/Argon2.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 254 "lib/Crypt/Argon2.c"

XS_EUPXS(XS_Crypt__Argon2_argon2_pass); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Argon2_argon2_pass)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "type, password, salt, t_cost, m_factor, parallelism, output_length");
    {
	SV *	RETVAL;
	Argon2_type	type = XS_unpack_Argon2_type(ST(0))
;
	SV *	password = ST(1)
;
	SV *	salt = ST(2)
;
	int	t_cost = (int)SvIV(ST(3))
;
	SV *	m_factor = ST(4)
;
	int	parallelism = (int)SvIV(ST(5))
;
	size_t	output_length = (size_t)SvUV(ST(6))
;

	RETVAL = argon2_pass(type, password, salt, t_cost, m_factor, parallelism, output_length);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Argon2_argon2id_pass); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Argon2_argon2id_pass)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 6)
       croak_xs_usage(cv,  "password, salt, t_cost, m_factor, parallelism, output_length");
    {
	SV *	RETVAL;
	SV *	password = ST(0)
;
	SV *	salt = ST(1)
;
	int	t_cost = (int)SvIV(ST(2))
;
	SV *	m_factor = ST(3)
;
	int	parallelism = (int)SvIV(ST(4))
;
	size_t	output_length = (size_t)SvUV(ST(5))
;
#line 110 "lib/Crypt/Argon2.xs"
	RETVAL = argon2_pass(ix, password, salt, t_cost, m_factor, parallelism, output_length);
#line 310 "lib/Crypt/Argon2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Argon2_argon2_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Argon2_argon2_raw)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "type, password, salt, t_cost, m_factor, parallelism, output_length");
    {
	SV *	RETVAL;
	Argon2_type	type = XS_unpack_Argon2_type(ST(0))
;
	SV *	password = ST(1)
;
	SV *	salt = ST(2)
;
	int	t_cost = (int)SvIV(ST(3))
;
	SV *	m_factor = ST(4)
;
	int	parallelism = (int)SvIV(ST(5))
;
	size_t	output_length = (size_t)SvUV(ST(6))
;

	RETVAL = argon2_raw(type, password, salt, t_cost, m_factor, parallelism, output_length);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Argon2_argon2id_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Argon2_argon2id_raw)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 6)
       croak_xs_usage(cv,  "password, salt, t_cost, m_factor, parallelism, output_length");
    {
	SV *	RETVAL;
	SV *	password = ST(0)
;
	SV *	salt = ST(1)
;
	int	t_cost = (int)SvIV(ST(2))
;
	SV *	m_factor = ST(3)
;
	int	parallelism = (int)SvIV(ST(4))
;
	size_t	output_length = (size_t)SvUV(ST(5))
;
#line 123 "lib/Crypt/Argon2.xs"
	RETVAL = argon2_raw(ix, password, salt, t_cost, m_factor, parallelism, output_length);
#line 372 "lib/Crypt/Argon2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Argon2_argon2d_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Argon2_argon2d_verify)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "encoded, password");
    {
#line 134 "lib/Crypt/Argon2.xs"
	const char* password_raw, *encoded_raw;
	STRLEN password_len, encoded_len;
	int status;
#line 392 "lib/Crypt/Argon2.c"
	bool	RETVAL;
	SV *	encoded = ST(0)
;
	SV *	password = ST(1)
;
#line 138 "lib/Crypt/Argon2.xs"
	encoded_raw = SvPVbyte(encoded, encoded_len);
	if (ix == 4) {
		const char* second_dollar = memchr(encoded_raw + 1, '$', encoded_len - 1);
		ix = find_argon2_type(encoded_raw + 1, second_dollar - encoded_raw - 1);
	}
	password_raw = SvPVbyte(password, password_len);
	status = argon2_verify(SvPVbyte_nolen(encoded), password_raw, password_len, ix);
	switch(status) {
		case ARGON2_OK:
			RETVAL = TRUE;
			break;
		case ARGON2_VERIFY_MISMATCH:
			RETVAL = FALSE;
			break;
		default:
			Perl_croak(aTHX_ "Could not verify %s tag: %s", argon2_type2string(ix, FALSE), argon2_error_message(status));
	}
#line 416 "lib/Crypt/Argon2.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Crypt__Argon2); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__Argon2)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        newXS_deffile("Crypt::Argon2::argon2_pass", XS_Crypt__Argon2_argon2_pass);
        cv = newXS_deffile("Crypt::Argon2::argon2d_pass", XS_Crypt__Argon2_argon2id_pass);
        XSANY.any_i32 = Argon2_d;
        cv = newXS_deffile("Crypt::Argon2::argon2i_pass", XS_Crypt__Argon2_argon2id_pass);
        XSANY.any_i32 = Argon2_i;
        cv = newXS_deffile("Crypt::Argon2::argon2id_pass", XS_Crypt__Argon2_argon2id_pass);
        XSANY.any_i32 = Argon2_id;
        newXS_deffile("Crypt::Argon2::argon2_raw", XS_Crypt__Argon2_argon2_raw);
        cv = newXS_deffile("Crypt::Argon2::argon2d_raw", XS_Crypt__Argon2_argon2id_raw);
        XSANY.any_i32 = Argon2_d;
        cv = newXS_deffile("Crypt::Argon2::argon2i_raw", XS_Crypt__Argon2_argon2id_raw);
        XSANY.any_i32 = Argon2_i;
        cv = newXS_deffile("Crypt::Argon2::argon2id_raw", XS_Crypt__Argon2_argon2id_raw);
        XSANY.any_i32 = Argon2_id;
        cv = newXS_deffile("Crypt::Argon2::argon2_verify", XS_Crypt__Argon2_argon2d_verify);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Crypt::Argon2::argon2d_verify", XS_Crypt__Argon2_argon2d_verify);
        XSANY.any_i32 = Argon2_d;
        cv = newXS_deffile("Crypt::Argon2::argon2i_verify", XS_Crypt__Argon2_argon2d_verify);
        XSANY.any_i32 = Argon2_i;
        cv = newXS_deffile("Crypt::Argon2::argon2id_verify", XS_Crypt__Argon2_argon2d_verify);
        XSANY.any_i32 = Argon2_id;
    }
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
